script.on_event(defines.events.on_built_entity, function(event)
  local entity = event.created_entity
  log (entity.name)
  local player = game.players[event.player_index]
  -- player.print('entity is ' .. entity.name)
  if entity.name ==  "private-chest-buffer" then
    add_to_table (entity, player)
  end
end)

function add_to_table (entity, player)
  try_init ()
  local chest = {entity = entity, player = player}
  table.insert(global.chests, chest)
  
  -- player.print('added  ' .. entity.name)
  -- player.print('table  ' .. serpent.block(global.chests))
  global.chests_amount = global.chests_amount + 1
end

function try_init ()
  if not global then global = {} end
  if not global.chests then global.chests = {} end
  if not global.chests_amount then global.chests_amount = 0 end
  if not global.tick_index then global.tick_index = 1 end
end

script.on_event(defines.events.on_tick, function(event)
  try_init ()
  if global.chests_amount == 0 then return end
  if global.tick_index > global.chests_amount then global.tick_index = 1 end
  set_requester (global.tick_index)
  global.tick_index = global.tick_index + 1
end)

function set_requester (tick_index)
  -- game.players[1].print('global ' .. serpent.block(global.chests))
  -- for i, v in pairs (global.chests) do
    -- game.players[1].print(i .. ' was ' .. serpent.block(v))
  -- end
  -- game.players[1].print('tick_index ' .. tick_index)
  local chest = global.chests[tick_index]
  local player = chest.player
  local entity = chest.entity
  -- if not chest then
    -- player.print('not chest ' .. entity.name)
    -- player.print('table ' .. serpent.block(chest))
  -- end
  if not (chest.entity.valid) then --remove
    global.chests_amount = global.chests_amount - 1
    table.remove(global.chests, tick_index)
    return
  end
  
  if not player.character then return end
  
  local player_slot_count = player.character.request_slot_count
  if player_slot_count == 0 then return end
  
  local entity_slot_count = entity.request_slot_count
  if entity_slot_count == 0 then return end
  
  local min_count = math.min(player_slot_count, entity_slot_count)
  for slot = 1, min_count do
    local request = player.character.get_request_slot(slot)
    if request then
      entity.set_request_slot(request, slot)
    end
  end
end

script.on_configuration_changed(function(data)
  for i, force in pairs (game.forces) do
    if force.technologies["construction-robotics"].researched then
      force.recipes["private-chest-buffer"].enabled = true
    end
  end
end)

















-- script.on_event(defines.events.on_player_created, function(event)
  -- local player = game.players[event.player_index]
  -- player.insert{name="iron-chest", count=50}
  -- player.insert{name="steel-chest", count=50}
  -- player.insert{name="logistic-chest-passive-provider", count=50}
  -- player.insert{name="logistic-chest-active-provider", count=50}
  -- player.insert{name="logistic-chest-storage", count=50}
  -- player.insert{name="logistic-chest-buffer", count=50}
  -- player.insert{name="logistic-chest-requester", count=50}
  -- player.insert{name="private-chest-buffer", count=50} -- my item
  -- player.insert{name="roboport", count=5}
  -- player.insert{name="logistic-robot", count=50}
  -- player.insert{name="construction-robot", count=50}
  -- player.insert{name="medium-electric-pole", count=50}
  -- player.insert{name="electric-energy-interface", count=50}
  -- player.insert{name="space-science-pack", count=2000}
-- end)